%global debug_package %{nil}
%global blaslib flexiblas
%global cmake_blas_flags -DBLA_VENDOR=FlexiBLAS

%bcond_with texlive
%bcond_with sparsehash
%bcond_with suitesparse
%bcond_with SuperLU
%bcond_with scotch
%bcond_with metis

Summary:       A lightweight C++ template library for vector and matrix math
Name:          eigen3
Version:       3.4.0
Release:       4%{?dist}
License:       MPLv2.0 and LGPLv2+ and BSD and Minpack
URL:           http://eigen.tuxfamily.org/index.php?title=Main_Page
Source0:       https://gitlab.com/libeigen/eigen/-/archive/%{version}/eigen-%{version}.tar.bz2

BuildRequires: %{blaslib}-devel  mpfr-devel gcc-gfortran cmake make gcc-c++ doxygen graphviz fftw-devel gmp-devel gsl-devel

%if %{with sparsehash}
BuildRequires: sparsehash-devel
%endif

%if %{with suitesparse}
BuildRequires: suitesparse-devel
%endif

%if %{with SuperLU}
BuildRequires: SuperLU-devel
%endif

%if %{with scotch}
BuildRequires: scotch-devel
%endif

%if %{with metis}
BuildRequires: metis-devel
%endif

%if %{with texlive}
BuildRequires: tex(latex)
%endif

%description
A lightweight C++ template library for vector and matrix math.

%package devel
Summary:        A lightweight C++ template library for vector and matrix math
Provides:       %{name} = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}
BuildArch:      noarch

%description devel
A lightweight C++ template library for vector and matrix math.

%prep
%autosetup -p1 -n eigen-%{version}

%build
%cmake \
    -DINCLUDE_INSTALL_DIR=%{_includedir}/%{name} \
    -DCMAKEPACKAGE_INSTALL_DIR=%{_datadir}/cmake/%{name} \
    %{cmake_blas_flags} \
    %{?with_SuperLU:-DSUPERLU_INCLUDES=%{_includedir}/SuperLU} \
    %{?with_scotch:-DSCOTCH_INCLUDES=%{_includedir} -DSCOTCH_LIBRARIES="scotch"} \
    %{?with_metis:-DMETIS_INCLUDES=%{_includedir} -DMETIS_LIBRARIES="metis"} \
    -DEIGEN_TEST_CXX11=ON

%cmake_build

%install
%cmake_install

%check

%files devel
%license COPYING.README COPYING.BSD COPYING.MPL2 COPYING.LGPL COPYING.MINPACK
%{_includedir}/%{name}
%{_datadir}/cmake/%{name}
%{_datadir}/pkgconfig/%{name}.pc

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.0-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Feb 22 2023 Shuo Wang <abushwang@tencent.com> - 3.4.0-1
- initial build
